'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var select = require('@highlight-ui/select');
var utilsCommons = require('@highlight-ui/utils-commons');
var utilsHooks = require('@highlight-ui/utils-hooks');
var classnames = require('classnames');
var tag = require('@highlight-ui/tag');
var typography = require('@highlight-ui/typography');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

var build = {exports: {}};

(function (module, exports) {
(function(a,b){module.exports=b();})('undefined'==typeof self?commonjsGlobal:self,function(){return function(a){function b(d){if(c[d])return c[d].exports;var e=c[d]={i:d,l:!1,exports:{}};return a[d].call(e.exports,e,e.exports,b),e.l=!0,e.exports}var c={};return b.m=a,b.c=c,b.d=function(a,c,d){b.o(a,c)||Object.defineProperty(a,c,{configurable:!1,enumerable:!0,get:d});},b.n=function(a){var c=a&&a.__esModule?function(){return a['default']}:function(){return a};return b.d(c,'a',c),c},b.o=function(a,b){return Object.prototype.hasOwnProperty.call(a,b)},b.p='./',b(b.s=2)}([function(a,b,c){Object.defineProperty(b,'__esModule',{value:!0}),b.useClickOutside=function(){function a(a){b&&b.current&&(b.current.contains(a.target)?h({hasClickedOutside:!1}):h({hasClickedOutside:!0}));}const b=Object(d.useRef)();var c=Object(d.useState)({hasClickedOutside:!1}),e=f(c,2);const g=e[0],h=e[1];return Object(d.useEffect)(()=>(window.PointerEvent?document.addEventListener('pointerdown',a):(document.addEventListener('mousedown',a),document.addEventListener('touchstart',a)),()=>{window.PointerEvent?document.addEventListener('pointerdown',a):(document.removeEventListener('mousedown',a),document.removeEventListener('touchstart',a));}),[]),[b,g.hasClickedOutside]};var d=c(1);c.n(d);var f=function(){function a(a,b){var c=[],d=!0,e=!1,f=void 0;try{for(var g,h=a[Symbol.iterator]();!(d=(g=h.next()).done)&&(c.push(g.value),!(b&&c.length===b));d=!0);}catch(a){e=!0,f=a;}finally{try{!d&&h['return']&&h['return']();}finally{if(e)throw f}}return c}return function(b,c){if(Array.isArray(b))return b;if(Symbol.iterator in Object(b))return a(b,c);throw new TypeError('Invalid attempt to destructure non-iterable instance')}}();},function(a){a.exports=React__default['default'];},function(a,b,c){a.exports=c(3);},function(a,b,c){Object.defineProperty(b,'__esModule',{value:!0});var d=c(0);c.d(b,'useClickOutside',function(){return d.useClickOutside});}])});

}(build));

var styles = {"container":"TagInput-module__3Hiv8t1e__v1-0-6","inputOutline":"TagInput-module__1SxgMouL__v1-0-6","focused":"TagInput-module__16f4thar__v1-0-6","inputElement":"TagInput-module__2lZcZwin__v1-0-6","tag":"TagInput-module__2Lqw0ZEv__v1-0-6","isHidden":"TagInput-module__a9UWROgi__v1-0-6","additionalTags":"TagInput-module__1VcTcx6n__v1-0-6","suffix":"TagInput-module__2YnRD65a__v1-0-6"};

var getTagsShownNumber = function (tagElements, containerElement, suffixRef) {
    if (!tagElements.length)
        return 0;
    if (!containerElement.current)
        return 0;
    var prefixWidth = suffixRef.current
        ? suffixRef.current.offsetWidth + 24
        : 0;
    var maxWidth = containerElement.current.offsetWidth - 40 - prefixWidth;
    var value = tagElements.slice(1).reduce(function (acc, item) {
        if (!item.current)
            return acc;
        if (maxWidth > acc.totalWidth + item.current.offsetWidth + 4) {
            return {
                items: acc.items + 1,
                totalWidth: acc.totalWidth + item.current.offsetWidth + 4,
            };
        }
        return {
            items: acc.items,
            totalWidth: acc.totalWidth + item.current.offsetWidth,
        };
    }, {
        items: 1,
        totalWidth: tagElements[0].current
            ? tagElements[0].current.offsetWidth + 4
            : 0,
    });
    return value.items;
};
var TagInput = React__default['default'].forwardRef(function (_a, ref) {
    var _b;
    var tags = _a.tags, onInputClick = _a.onInputClick, onInputChange = _a.onInputChange, onTagAdd = _a.onTagAdd, onTagRemove = _a.onTagRemove, suffix = _a.suffix, className = _a.className, metadata = _a.metadata;
    var _c = React.useState(''), inputValue = _c[0], setInputValue = _c[1];
    var _d = React.useState(false), isFocused = _d[0], setFocus = _d[1];
    var _e = React.useState([]), elRefs = _e[0], setElRefs = _e[1];
    var inputRef = React.useRef(null);
    var innerRef = React.useRef(null);
    var suffixRef = React.useRef(null);
    var _f = build.exports.useClickOutside(), clickOutsideRef = _f[0], hasClickedOutside = _f[1];
    var containerRef = utilsHooks.useForkRef([ref, clickOutsideRef, innerRef]);
    var _g = React.useState(0), tagsShownNumber = _g[0], setTagsShownNumber = _g[1];
    var addTag = function (tagText) {
        onTagAdd(tagText);
        setInputValue('');
        if (onInputChange) {
            onInputChange('');
        }
    };
    React.useEffect(function () {
        setElRefs(function (prevState) {
            return Array(tags.length)
                .fill(0)
                .map(function (_, i) { return prevState[i] || React.createRef(); });
        });
    }, [tags]);
    React.useEffect(function () {
        if (elRefs && innerRef) {
            setTagsShownNumber(getTagsShownNumber(elRefs, innerRef, suffixRef));
        }
    }, [elRefs, innerRef]);
    React.useEffect(function () { return setFocus(false); }, [hasClickedOutside]);
    return (React__default['default'].createElement("div", __assign({ className: classnames__default['default'](styles.container, className) }, utilsCommons.parseMetadata(metadata)),
        React__default['default'].createElement("div", { role: "none", onClick: function (e) {
                var _a;
                e.stopPropagation();
                e.preventDefault();
                (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
            }, ref: containerRef, className: classnames__default['default'](styles.inputOutline, (_b = {},
                _b[styles.focused] = isFocused,
                _b)) },
            tags.map(function (tag$1, index) {
                var _a;
                return (
                // eslint-disable-next-line react/no-array-index-key
                React__default['default'].createElement(React__default['default'].Fragment, { key: index },
                    React__default['default'].createElement(tag.Tag, __assign({}, tag$1, { metadata: utilsCommons.suffixMetadata(metadata, "tag-" + index), ref: elRefs[index], className: classnames__default['default'](styles.tag, (_a = {},
                            _a[styles.isHidden] = !isFocused && index >= tagsShownNumber,
                            _a)), onRemove: function (e) {
                            e.stopPropagation();
                            onTagRemove(tag$1, index);
                        } })),
                    !isFocused &&
                        index === tagsShownNumber - 1 &&
                        tags.length > tagsShownNumber && (React__default['default'].createElement(tag.Tag, { className: styles.additionalTags, text: "+" + (tags.length - tagsShownNumber) }))));
            }),
            React__default['default'].createElement("input", { ref: inputRef, className: styles.inputElement, value: inputValue, onKeyDown: function (event) {
                    var value = event.currentTarget.value;
                    if (value) {
                        if (event.key === 'Enter' || event.key === ',') {
                            addTag(value);
                        }
                    }
                }, onChange: function (event) {
                    var input = event.target.value;
                    if (input !== ',') {
                        setInputValue(input);
                        if (onInputChange) {
                            onInputChange(input);
                        }
                    }
                }, onFocus: function () {
                    if (!isFocused) {
                        setFocus(true);
                        if (onInputClick) {
                            onInputClick();
                        }
                    }
                }, onBlur: function (event) {
                    if (event.target.value) {
                        onTagAdd(event.target.value);
                        setInputValue('');
                        if (onInputChange) {
                            onInputChange('');
                        }
                    }
                } }),
            suffix && (React__default['default'].createElement(typography.Typography, { ref: suffixRef, variant: "caption-1", className: styles.suffix }, suffix)))));
});

function TagPickerWithRef(_a, ref) {
    var tags = _a.tags, onInputChange = _a.onInputChange, onTagAdd = _a.onTagAdd, onTagRemove = _a.onTagRemove, options = _a.options, onSelect = _a.onSelect, className = _a.className, metadata = _a.metadata, suffix = _a.suffix;
    var _b = React.useState(''), highlightedText = _b[0], setHighlightedText = _b[1];
    return (React__default['default'].createElement(select.Select, { ref: ref, className: className, metadata: metadata, renderTrigger: function (_a) {
            var onClick = _a.onClick, triggerRef = _a.ref;
            return (React__default['default'].createElement(TagInput, { metadata: utilsCommons.suffixMetadata(metadata, 'tag-input'), tags: tags, onInputClick: onClick, onInputChange: function (input) {
                    setHighlightedText(input);
                    if (onInputChange) {
                        onInputChange(input);
                    }
                }, onTagAdd: onTagAdd, onTagRemove: onTagRemove, suffix: suffix, ref: triggerRef }));
        }, closeOnSelect: true, highlightedText: highlightedText, searchable: false, options: options, renderEmptyState: function () { return null; }, onSelect: onSelect }));
}
TagPickerWithRef.displayName = 'TagPicker';
var TagPicker = React__default['default'].forwardRef(TagPickerWithRef);

exports.TagInput = TagInput;
exports.TagPicker = TagPicker;
//# sourceMappingURL=index.js.map
